
/*THE OVERLAPPING 20-tuples TEST  BITSTREAM, 20 BITS PER WORD, N words
 If n=2^22, should be 19205.3 missing 20-letter words, sigma 167.
 If n=2^21, should be 141909 missing 20-letter words, sigma   428.
 If n=2^20, should be 385750 missing 20-letter words, sigma   512 */

#include "header.h"

void
bitst (char *filename)
{
  const counter nb_pw = 20, power = 21, no_obs = 20;
  const counter no_bits = pow (2, power - 5), no_wds = pow (2, power);
  const counter dim = pow (2, nb_pw - 5);
  register counter mask = pow (2, nb_pw) - 1;
  const real mean = pow (2, nb_pw) * exp (-pow (2, (power - nb_pw))), std =
    428;

  register uniform w20, w32;
  register counter i, j, k, l, u, no_mswds = 0;
  counter bitmask[32], *wds;
  real z, cnt, err = -1;

  for (i = 0; i < 32; ++i)
    {
      bitmask[i] = pow (2, i);
    }



  printf ("\t\tBITSTREAM test results for %s.\n\n", filename);


  wds = (counter *) malloc (dim * sizeof (counter));

  w20 = uni (filename);

  cnt = 0;

  /*main loop */
  for (i = 1; i <= no_obs; ++i)
    {
      for (j = 0; j < dim; ++j)
	wds[j] = 0;

      for (j = 0; j < no_bits; ++j)
	{
	  w32 = uni (filename);

	  for (k = 1; k <= 32; ++k)
	    {
	      w20 <<= 1;
	      w20 += (w32 & 1);
	      w20 &= mask;
	      l = w20 & 31;
	      u = w20 >> 5;
	      wds[u] |= bitmask[l];
	      w32 >>= 1;
	    }
	}

      /*count no. of empty cells (=no. missing words) */
      no_mswds = 0;
      for (j = 0; j < dim; ++j)
	{
	  for (k = 0; k < 32; ++k)
	    {
	      if ((wds[j] & bitmask[k]) == 0)
		++no_mswds;
	    }
	}

      z = (no_mswds - mean) / std;
      cnt += 1 - Phi (z);

      if ((1 - Phi (z)) == 0)

	{
	  err = 0;
	}
      else if ((1 - Phi (z)) == 1)
	{

	  err = 1;

	}





    }

  uni ("close");
  free (wds);

  if (err == 0)
    {
      cnt = 0;
    }
  else
   if (err == 1)
    {
      cnt = 1;
    }
  else
    {
      cnt /= 20;
    }

  printf ("\t\tp-value: %f\n", cnt);
  results.bitstream = cnt;
  printf
    ("\t_____________________________________________________________\n\n");
  return;
}
