
#include "header.h"
#include "macro.h"

void
park (char *filename)
{
  const counter no_obs = 10, side = 100;
  const counter no_trials = 12000;
  const real ratio = side / UNIMAX, mu = 3523, sigma = 21.9;

  register counter no_succ, j, k;
  real xtmp, ytmp;
  real *x, *y, mean, var, z, *p, pvalue;
  counter sum = 0, ss = 0, i;


  printf ("\t\tCDPARK: result of %d tests on file %s\n", no_obs, filename);

  p = (real *) malloc (no_obs * sizeof (real));
  x = (real *) malloc (no_trials * sizeof (real));
  y = (real *) malloc (no_trials * sizeof (real));

#define PARK  { xtmp=ratio*uni(filename); ytmp=ratio*uni(filename);}
#define CRASH   (ABS(x[k]-xtmp)<=1 && ABS(y[k]-ytmp)<=1)

  for (i = 1; i <= no_obs; ++i)
    {
      PARK			/* the first parking */
	x[0] = xtmp;
      y[0] = ytmp;
      no_succ = 1;

      for (j = 0; j < no_trials; ++j)
	{
	  PARK			/* succesive parking */
	    for (k = 0;;)
	    {
	      if (CRASH)
		{
		  break;
		}

	      ++k;
	      if (k < no_succ)
		{
		  continue;
		}

	      x[no_succ] = xtmp;
	      y[no_succ] = ytmp;
	      ++no_succ;
	      break;
	    }
	}

      sum += no_succ;
      ss += no_succ * no_succ;

      z = (no_succ - mu) / sigma;
      p[i - 1] = 1 - Phi (z);


    }
  uni ("close");

  free (p);
  free (x);
  free (y);

  mean = (real) sum / no_obs;
  var = (real) ss / no_obs - mean * mean;


  pvalue = KStest (p, no_obs);
  printf ("\t\tp-value: %f\n\n", pvalue);
  results.cdpark = pvalue;
  printf ("\t_____________________________________________________________\n\n");
  return;
}
