#include "header.h"
#include "macro.h"

void
craptest (char *filename)
{
  const counter no_games = 200000;

  register counter i, win, no_win = 0, no_throw;
  register int out_1st, out_nxt;
  counter f[21];
  real Ef[21], sum, mean, std, t, pvalue_w, pvalue_th, rvalue = 0;


  /*compute the expected frequencies */
  sum = Ef[0] = 1 / 3.;
  for (i = 1; i < 20; ++i)
    {
      f[i] = 0;
      Ef[i] =
	(27 * pow (27 / 36., i - 1) + 40 * pow (26 / 36., i - 1) +
	 55 * pow (25 / 36., i - 1)) / 648;
      sum += Ef[i];
    }
  Ef[20] = 1. - sum;
  f[0] = f[20] = 0;

  /*playing the games */
#define DIE   1 + (int)( 6* (uni(filename)/UNIMAX) )
#define GAME_OVER  {++f[MIN(20,no_throw)]; no_win+=win;}

  for (i = 1; i <= no_games; ++i)
    {
      out_1st = DIE + DIE;
      no_throw = 0;

      if (out_1st == 7 || out_1st == 11)
	{
	  win = 1;
	  GAME_OVER continue;
	}

      if (out_1st == 2 || out_1st == 3 || out_1st == 12)
	{
	  win = 0;
	  GAME_OVER continue;
	}

      for (;;)
	{
	  out_nxt = DIE + DIE;
	  ++no_throw;
	  if (out_nxt == 7)
	    {
	      win = 0;
	      GAME_OVER break;
	    }

	  if (out_nxt == out_1st)
	    {
	      win = 1;
	      GAME_OVER break;
	    }
	}
    }
  uni ("close");

  mean = 244 * no_games / 495.;
  std = sqrt (mean * 251 / 495.);
  t = (no_win - mean) / std;

  printf ("\t\tRESULTS OF CRAPS TEST FOR %s \n", filename);

  pvalue_w = 1 - Phi (t);

  /* compute chi-square */
  sum = 0;
  for (i = 0; i < 21; ++i)
    {
      mean = no_games * Ef[i];
      t = (f[i] - mean) * (f[i] - mean) / mean;
      sum += t;

    }

  pvalue_th = 1 - Chisq (20, sum);

  printf ("\n\t\tSUMMARY of craptest on %s\n", filename);
  if ((pvalue_w == 0) || (pvalue_th == 0))
    {
      rvalue = 0;
    }
  else
   if ((pvalue_w == 1) || (pvalue_th == 1))
    {
      rvalue = 1;
    }

  else
    {
      rvalue = (pvalue_w + pvalue_th) / 2;
    }

  printf ("\t\tp-value: %.6f\n", rvalue);
  results.crap = rvalue;
  printf
    ("\t_____________________________________________________________\n\n");

  return;
}
