#include "header.h"
#include "macro.h"

void
sphere (char *filename)
{
  const counter no_obs = 20, no_pts = 4000, edge = 1000;
  const real ratio = edge / UNIMAX;

  int fcmpr (const void *u1, const void *u2);

  register counter i, j, k;
  real d, dmin;
  real *x, *y, *z, *p, r3, pvalue;

  printf ("\t\tThe 3DSPHERES test for file %s\n\n", filename);

  x = (real *) malloc (no_pts * sizeof (real));
  y = (real *) malloc (no_pts * sizeof (real));
  z = (real *) malloc (no_pts * sizeof (real));
  p = (real *) malloc (no_obs * sizeof (real));

  for (i = 1; i <= no_obs; ++i)
    {
      dmin = 10000000.;

      for (j = 0; j < no_pts; ++j)
	{
	  x[j] = ratio * uni (filename);
	  y[j] = ratio * uni (filename);
	  z[j] = ratio * uni (filename);
	}
      qsort (x, no_pts, sizeof (real), fcmpr);

      for (j = 0; j < no_pts - 1; ++j)
	{
	  for (k = j + 1; k < no_pts; ++k)
	    {
	      d = (x[k] - x[j]) * (x[k] - x[j]);

	      if (d >= dmin)
		break;
	      d +=
		(y[k] - y[j]) * (y[k] - y[j]) + (z[k] - z[j]) * (z[k] - z[j]);
	      dmin = MIN (dmin, d);
	    }
	}

      r3 = dmin * sqrt (dmin);
      p[i - 1] = 1 - exp (-MIN (r3 / 30., 20));

    }
  uni ("close");

  free (x);
  free (y);
  free (z);

  pvalue = KStest (p, no_obs);
  printf ("\t\tp-value: %f\n", pvalue);
  results.sphere3d = pvalue;
  printf
    ("\t_____________________________________________________________\n\n");

  free (p);

  return;
}

/*main()
{
  sphere("binc");

  return;
}*/
